---
title: MIME types (IANA media types)
slug: Web/HTTP/Basics_of_HTTP/MIME_types
tags:
  - Content-Type
  - Guide
  - HTTP
  - MIME Types
  - Meta
  - Request header
  - Response Header
  - application/javascript
  - application/json
  - application/xml
---
<div>{{HTTPSidebar}}</div>

<p><span class="seoSummary">A <strong>media type</strong> (also known as a <strong>Multipurpose Internet Mail Extensions or MIME type</strong>) is a standard that indicates the nature and format of a document, file, or assortment of bytes.</span> It is defined and standardized in IETF's {{RFC(6838)}}.</p>

<p>The <a href="https://www.iana.org/">Internet Assigned Numbers Authority (IANA)</a> is responsible for all official MIME types, and you can find the most up-to-date and complete list at their <a href="https://www.iana.org/assignments/media-types/media-types.xhtml">Media Types</a> page.</p>

<div class="warning">
<p><strong>Important:</strong> Browsers use the MIME type, <em>not the file extension</em>, to determine how to process a URL, so it's important that web servers send the correct MIME type in the response's {{HTTPHeader("Content-Type")}} header. If this is not correctly configured, browsers are likely to misinterpret the contents of files and sites will not work correctly, and downloaded files may be mishandled.</p>
</div>

<h2 id="Structure_of_a_MIME_type">Structure of a MIME type</h2>

<p>The simplest MIME type consists of a <var>type</var> and a <var>subtype</var>; these are each strings which, when concatenated with a slash (<code>/</code>) between them, comprise a MIME type. No whitespace is allowed in a MIME type:</p>

<pre class="syntaxbox"><var>type</var>/<var>subtype</var></pre>

<p>The <strong><var>type</var></strong> represents the general category into which the data type falls, such as <code>video</code> or <code>text</code>. The <strong><var>subtype</var></strong> identifies the exact kind of data of the specified type the MIME type represents. For example, for the MIME type <code>text</code>, the subtype might be <code>plain</code> (plain text), <code>html</code> ({{Glossary("HTML")}} source code), or <code>calendar</code> (for iCalendar/<code>.ics</code>) files.</p>

<p>Each type has its own set of possible subtypes, and a MIME type always has both a type and a subtype, never just one or the other.</p>

<p>An optional <strong>parameter</strong> can be added to provide additional details:</p>

<pre class="syntaxbox"><var>type</var>/<var>subtype</var>;<var>parameter</var>=<var>value</var></pre>

<p>For example, for any MIME type whose main type is <code>text</code>, the optional <code>charset</code> parameter can be used to specify the character set used for the characters in the data. If no <code>charset</code> is specified, the default is {{Glossary("ASCII")}} (<code>US-ASCII</code>) unless overridden by the {{Glossary("user agent", "user agent's")}} settings. To specify a UTF-8 text file, the MIME type <code>text/plain;charset=UTF-8</code> is used.</p>

<p>MIME types are case-insensitive but are traditionally written in lowercase, with the exception of parameter values, whose case may or may not have specific meaning.</p>

<h3 id="Types">Types</h3>

<p>There are two classes of type: <strong>discrete</strong> and <strong>multipart</strong>. Discrete types are types which represent a single file or medium, such as a single text or music file, or a single video. A multipart type is one which represents a document that's comprised of multiple component parts, each of which may have its own individual MIME type; or, a multipart type may encapsulate multiple files being sent together in one transaction. For example, multipart MIME types are used when attaching multiple files to an email.</p>

<h4 id="Discrete_types">Discrete types</h4>

<p>The discrete types currently registered with the IANA are:</p>

<dl>
 <dt><code>application</code><a href="https://www.iana.org/assignments/media-types/media-types.xhtml#application" style="float: right;">List at IANA</a></dt>
 <dd>Any kind of binary data that doesn't fall explicitly into one of the other types; either data that will be executed or interpreted in some way or binary data that requires a specific application or category of application to use. Generic binary data (or binary data whose true type is unknown) is <code>application/octet-stream</code>. Other common examples include <code>application/pdf</code>, <code>application/pkcs8</code>, and <code>application/zip</code>.</dd>
 <dt><code>audio</code> <a href="https://www.iana.org/assignments/media-types/media-types.xhtml#audio" style="float: right;">List at IANA</a></dt>
 <dd>Audio or music data. Examples include <code>audio/mpeg</code>, <code>audio/vorbis</code>.</dd>
 <dt><code>example</code></dt>
 <dd>Reserved for use as a placeholder in examples showing how to use MIME types. These should never be used outside of sample code listings and documentation. <code>example</code> can also be used as a subtype; for instance, in an example related to working with audio on the web, the MIME type <code>audio/example</code> can be used to indicate that the type is a placeholder and should be replaced with an appropriate one when using the code in the real world.</dd>
 <dt><code>font</code> <a href="https://www.iana.org/assignments/media-types/media-types.xhtml#font" style="float: right;">List at IANA</a></dt>
 <dd>Font/typeface data. Common examples include <code>font/woff</code>, <code>font/ttf</code>, and <code>font/otf</code>.</dd>
 <dt><code>image</code> <a href="https://www.iana.org/assignments/media-types/media-types.xhtml#image" style="float: right;">List at IANA</a></dt>
 <dd>Image or graphical data including both bitmap and vector still images as well as animated versions of still image formats such as animated {{Glossary("GIF")}} or APNG. Common examples are <code>image/jpeg</code>, <code>image/png</code>, and <code>image/svg+xml</code>.</dd>
 <dt><code>model</code> <a href="https://www.iana.org/assignments/media-types/media-types.xhtml#model" style="float: right;">List at IANA</a></dt>
 <dd>Model data for a 3D object or scene. Examples include <code>model/3mf</code> and <code>model/vml</code>.</dd>
 <dt><code>text</code> <a href="https://www.iana.org/assignments/media-types/media-types.xhtml#text" style="float: right;">List at IANA</a></dt>
 <dd>Text-only data including any human-readable content, source code, or textual data such as comma-separated value (CSV) formatted data. Examples include <code>text/plain</code>, <code>text/csv</code>, and <code>text/html</code>.</dd>
 <dt><code>video</code> <a href="https://www.iana.org/assignments/media-types/media-types.xhtml#video" style="float: right;">List at IANA</a></dt>
 <dd>Video data or files, such as MP4 movies (<code>video/mp4</code>).</dd>
</dl>

<p>For text documents without a specific subtype, <code>text/plain</code> should be used. Similarly, for binary documents without a specific or known subtype, <code>application/octet-stream</code> should be used.</p>

<h4 id="Multipart_types">Multipart types</h4>

<p id="sect1"><strong>Multipart</strong> types indicate a category of document broken into pieces, often with different MIME types; they can also be used — especially in email scenarios — to represent multiple, separate files which are all part of the same transaction. They represent a <strong>composite document</strong>.</p>

<p>With the exception of <code>multipart/form-data</code>, used in the {{HTTPMethod("POST")}} method of <a href="/en-US/docs/Web/Guide/HTML/Forms">HTML Forms</a>, and <code>multipart/byteranges</code>, used with {{HTTPStatus("206")}} <code>Partial Content</code> to send part of a document, HTTP doesn't handle multipart documents in a special way: the message is transmitted to the browser (which will likely show a "Save As" window if it doesn't know how to display the document).</p>

<p>There are two multipart types:</p>

<dl>
 <dt><code>message</code> <a href="https://www.iana.org/assignments/media-types/media-types.xhtml#message" style="float: right;">List at IANA</a></dt>
 <dd>A message that encapsulates other messages. This can be used, for instance, to represent an email that includes a forwarded message as part of its data, or to allow sending very large messages in chunks as if it were multiple messages. Examples include <code>message/rfc822</code> (for forwarded or replied-to message quoting) and <code>message/partial</code> to allow breaking a large message into smaller ones automatically to be reassembled by the recipient.</dd>
 <dt><code>multipart</code> <a href="https://www.iana.org/assignments/media-types/media-types.xhtml#multipart" style="float: right;">List at IANA</a></dt>
 <dd>Data that is comprised of multiple components which may individually have different MIME types. Examples include <code>multipart/form-data</code> (for data produced using the {{domxref("FormData")}} API) and <code>multipart/byteranges</code> (defined in {{RFC(7233, "5.4.1")}} and used with {{Glossary("HTTP")}}'s {{HTTPStatus(206)}} "Partial Content" response returned when the fetched data is only part of the content, such as is delivered using the {{HTTPHeader("Range")}} header).</dd>
</dl>

<h2 id="Important_MIME_types_for_Web_developers">Important MIME types for Web developers</h2>

<h3 id="applicationoctet-stream">application/octet-stream</h3>

<p>This is the default for binary files. As it means <em>unknown binary</em> file, browsers usually don't execute it, or even ask if it should be executed. They treat it as if the {{HTTPHeader("Content-Disposition")}} header was set to <code>attachment</code>, and propose a "Save As" dialog.</p>

<h3 id="textplain">text/plain</h3>

<p>This is the default for textual files. Even if it really means "unknown textual file," browsers assume they can display it.</p>

<div class="notecard note">
<p>Note that <code>text/plain</code> does not mean "any kind of textual data." If they expect a specific kind of textual data, they will likely not consider it a match. Specifically if they download a <code>text/plain</code> file from a {{HTMLElement("link")}} element declaring a CSS file, they will not recognize it as a valid CSS file if presented with <code>text/plain</code>. The CSS mime type <code>text/css</code> must be used.</p>
</div>

<h3 id="textcss">text/css</h3>

<p>CSS files used to style a Web page <strong>must</strong> be sent with <code>text/css</code>. If a server doesn't recognize the <code>.css</code> suffix for CSS files, it may send them with <code>text/plain</code> or <code>application/octet-stream</code> MIME types. If so, they won't be recognized as CSS by most browsers and will be ignored.</p>

<h3 id="texthtml">text/html</h3>

<p>All HTML content should be served with this type. Alternative MIME types for XHTML (like <code>application/xhtml+xml</code>) are mostly useless nowadays.</p>

<div class="notecard note">
<p><strong>Note:</strong> Use <code>application/xml</code> or <code>application/xhtml+xml</code> if you want XML’s strict parsing rules, <code><a href="/en-US/docs/Web/API/CDATASection">&lt;![CDATA[…]]&gt;</a></code> sections, or elements that aren't from HTML/SVG/MathML namespaces.</p>
</div>

<h3 id="textjavascript"><span id="JavaScript_types">text/javascript</span></h3>

<p>Per the HTML specification, JavaScript files should always be served using the MIME type <code>text/javascript</code>. No other values are considered valid, and using any of those may result in scripts that do not load or run.</p>

<p>For historical reasons, the <a href="https://mimesniff.spec.whatwg.org/">MIME Sniffing Standard</a> (the definition of how browsers should interpret media types and figure out what to do with content that doesn't have a valid one) allows JavaScript to be served using any MIME type that essentially matches any of the following:</p>

<ul>
 <li><code>application/javascript</code></li>
 <li><code>application/ecmascript</code></li>
 <li><code>application/x-ecmascript</code> {{Non-standard_Inline}}</li>
 <li><code>application/x-javascript</code> {{Non-standard_Inline}}</li>
 <li><code>text/javascript</code></li>
 <li><code>text/ecmascript</code></li>
 <li><code>text/javascript1.0</code> {{Non-standard_Inline}}</li>
 <li><code>text/javascript1.1</code> {{Non-standard_Inline}}</li>
 <li><code>text/javascript1.2</code> {{Non-standard_Inline}}</li>
 <li><code>text/javascript1.3</code> {{Non-standard_Inline}}</li>
 <li><code>text/javascript1.4</code> {{Non-standard_Inline}}</li>
 <li><code>text/javascript1.5</code> {{Non-standard_Inline}}</li>
 <li><code>text/jscript</code> {{Non-standard_Inline}}</li>
 <li><code>text/livescript</code> {{Non-standard_Inline}}</li>
 <li><code>text/x-ecmascript</code> {{Non-standard_Inline}}</li>
 <li><code>text/x-javascript</code> {{Non-standard_Inline}}</li>
</ul>

<div class="notecard note">
<p><strong>Note:</strong> Even though any given {{Glossary("user agent")}} may support any or all of these, you should only use <code>text/javascript</code>. It's the only MIME type guaranteed to work now and into the future.</p>
</div>

<p>Some content you find may have a <code>charset</code> parameter at the end of the <code>text/javascript</code> media type, to specify the character set used to represent the code's content. This is not valid, and in most cases will result in a script not being loaded.</p>

<h3 id="Image_types">Image types</h3>

<p>Files whose MIME type is <code>image</code> contain image data. The subtype specifies which specific image file format the data represents. Only a few image types are used commonly enough to be considered safe for use on web pages:</p>

<p>{{page("en-US/docs/Web/Media/Formats/Image_types", "table-of-image-file-types")}}</p>

<h3 id="Audio_and_video_types">Audio and video types</h3>

<p>As is the case for images, HTML doesn't mandate that web browsers support any specific file and codec types for the {{HTMLElement("audio")}} and {{HTMLElement("video")}} elements, so it's important to consider your target audience and the range of browsers (and versions of those browsers) they may be using when choosing the file type and codecs to use for media.</p>

<p>Our <a href="/en-US/docs/Web/Media/Formats/Containers">media container formats guide</a> provides a list of the file types that are commonly supported by web browsers, including information about what their special use cases may be, any drawbacks they have, and compatibility information, along with other details.</p>

<p>The <a href="/en-US/docs/Web/Media/Formats/Audio_codecs">audio codec</a> and <a href="/en-US/docs/Web/Media/Formats/Video_codecs">video codec</a> guides list the various codecs that web browsers often support, providing compatibility details along with technical information such as how many audio channels they support, what sort of compression is used, and what bit rates and so forth they're useful at. The <a href="/en-US/docs/Web/Media/Formats/WebRTC_codecs">codecs used by WebRTC</a> guide expands upon this by specifically covering the codecs supported by the major web browsers, so you can choose the codecs that best cover the range of browsers you wish to support.</p>

<p>As for MIME types of audio or video files, they typically specify the container format (file type). The optional <a href="/en-US/docs/Web/Media/Formats/codecs_parameter">codecs parameter</a> can be added to the MIME type to further specify which codecs to use and what options were used to encode the media, such as codec profile, level, or other such information.</p>

<p>The most commonly used MIME types used for web content are listed below. This isn't a complete list of all the types that may be available, however. See the <a href="/en-US/docs/Web/Media/Formats/Containers">media container formats</a> guide for that.</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">MIME type</th>
   <th scope="col">Audio or video type</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>audio/wave</code><br>
    <code>audio/wav</code><br>
    <code>audio/x-wav</code><br>
    <code>audio/x-pn-wav</code></td>
   <td>An audio file in the WAVE container format. The PCM audio codec (WAVE codec "1") is often supported, but other codecs have limited support (if any).</td>
  </tr>
  <tr>
   <td><code>audio/webm</code></td>
   <td>An audio file in the WebM container format. Vorbis and Opus are the codecs officially supported by the WebM specification.</td>
  </tr>
  <tr>
   <td><code>video/webm</code></td>
   <td>A video file, possibly with audio, in the WebM container format. VP8 and VP9 are the most common video codecs; Vorbis and Opus the most common audio codecs.</td>
  </tr>
  <tr>
   <td><code>audio/ogg</code></td>
   <td>An audio file in the Ogg container format. Vorbis is the most common audio codec used in such a container; however, Opus is now supported by Ogg as well.</td>
  </tr>
  <tr>
   <td><code>video/ogg</code></td>
   <td>A video file, possibly with audio, in the Ogg container format. Theora is the usual video codec used within it; Vorbis is the usual audio codec, although Opus is becoming more common.</td>
  </tr>
  <tr>
   <td><code>application/ogg</code></td>
   <td>An audio or video file using the Ogg container format. Theora is the usual video codec used within it; Vorbis is the usual audio codec.</td>
  </tr>
 </tbody>
</table>

<h3 id="multipartform-data">multipart/form-data</h3>

<p>The <code>multipart/form-data</code> type can be used when sending the values of a completed <a href="/en-US/docs/Web/Guide/HTML/Forms">HTML Form</a> from browser to server.</p>

<p>As a multipart document format, it consists of different parts, delimited by a boundary (a string starting with a double dash <code>--</code>). Each part is its own entity with its own HTTP headers, {{HTTPHeader("Content-Disposition")}}, and {{HTTPHeader("Content-Type")}} for file uploading fields.</p>

<pre class="syntaxbox">Content-Type: multipart/form-data; boundary=aBoundaryString
(other headers associated with the multipart document as a whole)

--aBoundaryString
Content-Disposition: form-data; name="myFile"; filename="img.jpg"
Content-Type: image/jpeg

(data)
--aBoundaryString
Content-Disposition: form-data; name="myField"

(data)
--aBoundaryString
(more subparts)
--aBoundaryString--

</pre>

<p>The following <code>&lt;form&gt;</code>:</p>

<pre class="brush: html">&lt;form action="http://localhost:8000/" method="post" enctype="multipart/form-data"&gt;
  &lt;label&gt;Name: &lt;input name="myTextField" value="Test"&gt;&lt;/label&gt;
  &lt;label&gt;&lt;input type="checkbox" name="myCheckBox"&gt; Check&lt;/label&gt;
  &lt;label&gt;Upload file: &lt;input type="file" name="myFile" value="test.txt"&gt;&lt;/label&gt;
  &lt;button&gt;Send the file&lt;/button&gt;
&lt;/form&gt;</pre>

<p>will send this message:</p>

<pre>POST / HTTP/1.1
Host: localhost:8000
User-Agent: Mozilla/5.0 (Macintosh; Intel Mac OS X 10.9; rv:50.0) Gecko/20100101 Firefox/50.0
Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8
Accept-Language: en-US,en;q=0.5
Accept-Encoding: gzip, deflate
Connection: keep-alive
Upgrade-Insecure-Requests: 1
Content-Type: multipart/form-data; boundary=---------------------------8721656041911415653955004498
Content-Length: 465

-----------------------------8721656041911415653955004498
Content-Disposition: form-data; name="myTextField"

Test
-----------------------------8721656041911415653955004498
Content-Disposition: form-data; name="myCheckBox"

on
-----------------------------8721656041911415653955004498
Content-Disposition: form-data; name="myFile"; filename="test.txt"
Content-Type: text/plain

Simple file.
-----------------------------8721656041911415653955004498--

</pre>

<h3 id="multipartbyteranges">multipart/byteranges</h3>

<p>The <code>multipart/byteranges</code> MIME type is used to send partial responses to the browser.</p>

<p>When the {{HTTPStatus("206")}}<code> Partial Content</code> status code is sent, this MIME type indicates that the document is composed of several parts, one for each of the requested ranges. Like other multipart types, the {{HTTPHeader("Content-Type")}} uses a <code>boundary</code> to separate the pieces. Each piece has a {{HTTPHeader("Content-Type")}} header with its actual type and a {{HTTPHeader("Content-Range")}} of the range it represents.</p>

<pre><code>HTTP/1.1 206 Partial Content
Accept-Ranges: bytes
Content-Type: multipart/byteranges; boundary=3d6b6a416f9b5
Content-Length: 385

--3d6b6a416f9b5
Content-Type: text/html
Content-Range: bytes 100-200/1270

eta http-equiv="Content-type" content="text/html; charset=utf-8" /&gt;
    &lt;meta name="vieport" content
--3d6b6a416f9b5
Content-Type: text/html
Content-Range: bytes 300-400/1270

-color: #f0f0f2;
        margin: 0;
        padding: 0;
        font-family: "Open Sans", "Helvetica
--3d6b6a416f9b5--</code></pre>

<h2 id="Importance_of_setting_the_correct_MIME_type">Importance of setting the correct MIME type</h2>

<p>Most web servers send unrecognized resources as the <code>application/octet-stream</code> MIME type. For security reasons, most browsers do not allow setting a custom default action for such resources, forcing the user to save it to disk to use it.</p>

<p>Some common incorrect server configurations:</p>

<ul>
 <li>
  <p>RAR-compressed files. In this case, the ideal would be the true type of the original files; this is often impossible as .RAR files can hold several resources of different types. In this case, configure the server to send <code>application/x-rar-compressed</code>.</p>
 </li>
 <li>
  <p>Audio and video. Only resources with the correct MIME Type will be played in {{HTMLElement("video")}} or {{HTMLElement("audio")}} elements. Be sure to specify the correct <a href="/en-US/docs/Web/Media/Formats">media type for audio and video</a>.</p>
 </li>
 <li>
  <p>Proprietary file types. Avoid using <code>application/octet-stream</code> as most browsers do not allow defining a default behavior (like "Open in Word") for this generic MIME type. A specific type like <code>application/vnd.mspowerpoint</code> lets users open such files automatically in the presentation software of their choice.</p>
 </li>
</ul>

<h2 id="MIME_sniffing">MIME sniffing</h2>

<p>In the absence of a MIME type, or in certain cases where browsers believe they are incorrect, browsers may perform <em>MIME sniffing</em> — guessing the correct MIME type by looking at the bytes of the resource.</p>

<p>Each browser performs MIME sniffing differently and under different circumstances. (For example, Safari will look at the file extension in the URL if the sent MIME type is unsuitable.) There are security concerns as some MIME types represent executable content. Servers can prevent MIME sniffing by sending the {{HTTPHeader("X-Content-Type-Options")}} header.</p>

<h2 id="Other_methods_of_conveying_document_type">Other methods of conveying document type</h2>

<p>MIME types are not the only way to convey document type information:</p>

<ul>
 <li>Filename suffixes are sometimes used, especially on Microsoft Windows. Not all operating systems consider these suffixes meaningful (such as Linux and MacOS), and there is no guarantee they are correct.</li>
 <li>Magic numbers. The syntax of different formats allows file-type inference by looking at their byte structure. For example, GIF files start with the <code>47 49 46 38 39</code> hexadecimal value (<code>GIF89</code>), and PNG files with <code>89 50 4E 47</code> (<code>.PNG</code>). Not all file types have magic numbers, so this is not 100% reliable either.</li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/Media">Web media technologies</a></li>
 <li><a href="/en-US/docs/Web/Media/Formats">Guide to media types used on the web</a></li>
 <li><a href="/en-US/docs/Web/Security/Securing_your_site/Configuring_server_MIME_types">Properly configuring server MIME types</a></li>
</ul>
